unit Package_1Unit;

interface

uses
  System.ComponentModel,
  System.Collections,
  Borland.Eco.Services,
  Borland.Eco.ObjectRepresentation,
  Borland.Eco.ObjectImplementation,
  Borland.Eco.UmlRt,
  Borland.Eco.UmlCodeAttributes;

type
  c_invoice = class;
  c_item = class;
  [UmlElement('Package', Id='5A14E2D1-D6ED-4181-8CF8-864804DD65C4')]
  [EcoCodeGenVersion('2.0')]
  [UmlMetaAttribute('ownedElement', TypeOf(c_invoice))]
  [UmlMetaAttribute('ownedElement', TypeOf(c_item))]
  Package_1 = class
  public
  type
    [UmlElement('Association', Id='4dd3abe2-f0c6-4c4a-8d5f-1cd65b59b4fd')]
    c_itemhas_itemc_invoicefrom_invoice = class
    end;
  end;

  [assembly: RuntimeRequired(TypeOf(Package_1))]
  Ic_invoiceList = interface;

  [UmlCollection(TypeOf(c_invoice))]
  Ic_invoiceList = interface(ICollection)
    {$REGION 'ECO generated code'}
    function get_Item(index: Integer): c_invoice;
    procedure set_Item(index: Integer; Value: c_invoice);
    property Item[index: Integer]: c_invoice read get_Item write set_Item; default;
    function Add(value: c_invoice): Integer;
    function Contains(value: c_invoice): Boolean;
    function IndexOf(value: c_invoice): Integer;
    procedure Insert(index: Integer; value: c_invoice);
    procedure Remove(value: c_invoice);
    procedure Clear;
    procedure RemoveAt(index: Integer);
    {$ENDREGION 'ECO generated code'}
  end;
  Ic_itemList = interface;

  [UmlElement(Id='0ddc116f-b101-46c9-a504-db68f6109ece')]
  c_invoice = class(System.Object, ILoopBack)
    {$REGION 'ECO generated code'}
  public
  type
    Eco_LoopbackIndices = class
    public
    const
      Eco_FirstMember = 0;
    const
      Eco_MemberCount = (Eco_FirstMember + 3);
    const
      m_invoice_number = Eco_FirstMember;
    const
      m_customer = (Eco_LoopbackIndices.m_invoice_number + 1);
    const
      has_item = (Eco_LoopbackIndices.m_customer + 1);
    end;

    c_invoiceListAdapter = class(ObjectListAdapter, Ic_invoiceList)
    public
      constructor Create(source: IList);
      function get_Item(index: Integer): c_invoice;
      procedure set_Item(index: Integer; Value: c_invoice);
      property Item[index: Integer]: c_invoice read get_Item write set_Item; default;
      function Add(value: c_invoice): Integer;
      function Contains(value: c_invoice): Boolean;
      function IndexOf(value: c_invoice): Integer;
      procedure Insert(index: Integer; value: c_invoice);
      procedure Remove(value: c_invoice);
    end;
    
  strict protected
    eco_Content: IContent;
  strict private
    function IObjectProvider.AsIObject = IObjectProvider_AsIObject;
    function IObjectProvider_AsIObject: IObject;
  public
    function AsIObject: IObjectInstance;
    procedure set_MemberByIndex(index: Integer; value: System.Object); virtual;
    function get_MemberByIndex(index: Integer): System.Object; virtual;
    function get_m_customer: string;
    procedure set_m_customer(Value: string);
    [UmlElement(Id='e680eca0-a997-406d-8b45-85ce421f041a', Index=Eco_LoopbackIndices.m_customer)]
    property m_customer: string read get_m_customer write set_m_customer;
    function get_m_invoice_number: Integer;
    procedure set_m_invoice_number(Value: Integer);
    [UmlElement(Id='ad612d54-d746-411f-8e1d-5c098813949b', Index=Eco_LoopbackIndices.m_invoice_number)]
    property m_invoice_number: Integer read get_m_invoice_number write set_m_invoice_number;
    function get_has_item: Ic_itemList;
    [UmlElement('AssociationEnd', Index=Eco_LoopbackIndices.has_item, Id='54f214e' +
    '7-c2dc-4808-a4b4-8f19e2204581')]
    [UmlMetaAttribute('association', TypeOf(Package_1.c_itemhas_itemc_invoicefrom_invoice), Index=0)]
    [UmlMetaAttribute('multiplicity', '1..*')]
    property has_item: Ic_itemList read get_has_item;
    [UmlElement(Id='e14399f5-d727-4755-9346-1b153a5a644b')]
    function f_first_upper: String;
    [UmlElement(Id='1e1ca81b-d079-450c-b0de-8b4624350696')]
    procedure do_compute;
  strict protected
    procedure Deinitialize(serviceProvider: IEcoServiceProvider);
    procedure Initialize(serviceProvider: IEcoServiceProvider);
    /// <summary>For Framework Internal use only</summary>
  public
    constructor Create(content: IContent); overload;
    {$ENDREGION 'ECO generated code'}
    constructor Create(serviceProvider: IEcoServiceProvider); overload;
    function ToString: String; Override;
  end;

  [UmlCollection(TypeOf(c_item))]
  Ic_itemList = interface(ICollection)
    {$REGION 'ECO generated code'}
    function get_Item(index: Integer): c_item;
    procedure set_Item(index: Integer; Value: c_item);
    property Item[index: Integer]: c_item read get_Item write set_Item; default;
    function Add(value: c_item): Integer;
    function Contains(value: c_item): Boolean;
    function IndexOf(value: c_item): Integer;
    procedure Insert(index: Integer; value: c_item);
    procedure Remove(value: c_item);
    procedure Clear;
    procedure RemoveAt(index: Integer);
    {$ENDREGION 'ECO generated code'}
  end;
  
  [UmlElement(Id='f2fcb090-d435-4950-9c1d-8d9c238cc495')]
  c_item = class(System.Object, ILoopBack)
    {$REGION 'ECO generated code'}
  public
  type
    Eco_LoopbackIndices = class
    public
    const
      Eco_FirstMember = 0;
    const
      Eco_MemberCount = (Eco_FirstMember + 2);
    const
      m_quantity = Eco_FirstMember;
    const
      from_invoice = (Eco_LoopbackIndices.m_quantity + 1);
    end;

    c_itemListAdapter = class(ObjectListAdapter, Ic_itemList)
    public
      constructor Create(source: IList);
      function get_Item(index: Integer): c_item;
      procedure set_Item(index: Integer; Value: c_item);
      property Item[index: Integer]: c_item read get_Item write set_Item; default;
      function Add(value: c_item): Integer;
      function Contains(value: c_item): Boolean;
      function IndexOf(value: c_item): Integer;
      procedure Insert(index: Integer; value: c_item);
      procedure Remove(value: c_item);
    end;
    
  strict protected
    eco_Content: IContent;
  strict private
    function IObjectProvider.AsIObject = IObjectProvider_AsIObject;
    function IObjectProvider_AsIObject: IObject;
  public
    function AsIObject: IObjectInstance;
    procedure set_MemberByIndex(index: Integer; value: System.Object); virtual;
    function get_MemberByIndex(index: Integer): System.Object; virtual;
    function get_m_quantity: Integer;
    procedure set_m_quantity(Value: Integer);
    [UmlElement(Id='c2d014a7-8a44-47e3-922e-dab354dac357', Index=Eco_LoopbackIndices.m_quantity)]
    property m_quantity: Integer read get_m_quantity write set_m_quantity;
    function get_from_invoice: c_invoice;
    procedure set_from_invoice(Value: c_invoice);
    [UmlElement('AssociationEnd', Index=Eco_LoopbackIndices.from_invoice, Id='1b3' +
    '3fb3b-b2d4-4926-a873-1bce41df449e')]
    [UmlMetaAttribute('association', TypeOf(Package_1.c_itemhas_itemc_invoicefrom_invoice), Index=1)]
    [UmlMetaAttribute('multiplicity', '1')]
    property from_invoice: c_invoice read get_from_invoice write set_from_invoice;
  strict protected
    procedure Deinitialize(serviceProvider: IEcoServiceProvider);
    procedure Initialize(serviceProvider: IEcoServiceProvider);
    /// <summary>For Framework Internal use only</summary>
  public
    constructor Create(content: IContent); overload;
    {$ENDREGION 'ECO generated code'}
    constructor Create(serviceProvider: IEcoServiceProvider); overload;
    function ToString: String; Override;
  end;

implementation

function c_invoice.IObjectProvider_AsIObject: IObject;
begin
  Result := Self.eco_Content.AsIObject;
end;

function c_invoice.AsIObject: IObjectInstance;
begin
  Result := Self.eco_Content.AsIObject;
end;

procedure c_invoice.set_MemberByIndex(index: Integer; value: System.Object);
begin
  raise System.IndexOutOfRangeException.Create;
end;

function c_invoice.get_MemberByIndex(index: Integer): System.Object;
begin
  raise System.IndexOutOfRangeException.Create;
end;

procedure c_invoice.Deinitialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self.eco_Content <> nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    factory.CreateContentFailed(Self.eco_Content, Self);
    Self.eco_Content := nil;
  end;
end;

procedure c_invoice.Initialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self.eco_Content = nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    Self.eco_Content := factory.CreateContent(Self);
    Self.eco_Content.LoopbackValid;
  end;
end;

/// <summary>For Framework Internal use only</summary>
constructor c_invoice.Create(content: IContent);
begin
  inherited Create;
  Self.eco_Content := content;
  content.AssertLoopbackUnassigned;
end;

{$ENDREGION 'ECO generated code'}

constructor c_invoice.Create(serviceProvider: IEcoServiceProvider);
begin
  inherited Create;
  Self.Initialize(serviceProvider);
  try
    // User code here
  except
    on System.Exception do
    begin
      Self.Deinitialize(serviceProvider);
      raise;
    end;
  end;
end;

function c_invoice.ToString: String; 
  begin
    Result:= m_customer+ ' '+ m_invoice_number.ToString;
  end;

procedure c_invoice.do_compute;
begin
end;

function c_invoice.f_first_upper: String;
begin
  Result:= m_customer.ToUpper;
end;

function c_invoice.get_has_item: Ic_itemList;
begin
  Result := Package_1Unit.c_item.c_itemListAdapter.Create((IList(Self.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.has_item))));
end;

function c_invoice.get_m_invoice_number: Integer;
begin
  Result := (Integer(Self.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.m_invoice_number)));
end;

procedure c_invoice.set_m_invoice_number(Value: Integer);
begin
  Self.eco_Content.set_MemberByIndex(Eco_LoopbackIndices.m_invoice_number, (System.Object(Value)));
end;

function c_invoice.get_m_customer: string;
begin
  Result := (string(Self.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.m_customer)));
end;

procedure c_invoice.set_m_customer(Value: string);
begin
  Self.eco_Content.set_MemberByIndex(Eco_LoopbackIndices.m_customer, (System.Object(Value)));
end;

constructor c_invoice.c_invoiceListAdapter.Create(source: IList);
begin
  inherited Create(source);
end;

function c_invoice.c_invoiceListAdapter.get_Item(index: Integer): c_invoice;
begin
  Result := (c_invoice(inherited Adaptee[index]));
end;

procedure c_invoice.c_invoiceListAdapter.set_Item(index: Integer; Value: c_invoice);
begin
  inherited Adaptee[index] := value;
end;

function c_invoice.c_invoiceListAdapter.Add(value: c_invoice): Integer;
begin
  Result := Self.Adaptee.Add(value);
end;

function c_invoice.c_invoiceListAdapter.Contains(value: c_invoice): Boolean;
begin
  Result := Self.Adaptee.Contains(value);
end;

function c_invoice.c_invoiceListAdapter.IndexOf(value: c_invoice): Integer;
begin
  Result := Self.Adaptee.IndexOf(value);
end;

procedure c_invoice.c_invoiceListAdapter.Insert(index: Integer; value: c_invoice);
begin
  Self.Adaptee.Insert(index, value);
end;

procedure c_invoice.c_invoiceListAdapter.Remove(value: c_invoice);
begin
  Self.Adaptee.Remove(value);
end;

function c_item.IObjectProvider_AsIObject: IObject;
begin
  Result := Self.eco_Content.AsIObject;
end;

function c_item.AsIObject: IObjectInstance;
begin
  Result := Self.eco_Content.AsIObject;
end;

procedure c_item.set_MemberByIndex(index: Integer; value: System.Object);
begin
  raise System.IndexOutOfRangeException.Create;
end;

function c_item.get_MemberByIndex(index: Integer): System.Object;
begin
  raise System.IndexOutOfRangeException.Create;
end;

procedure c_item.Deinitialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self.eco_Content <> nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    factory.CreateContentFailed(Self.eco_Content, Self);
    Self.eco_Content := nil;
  end;
end;

procedure c_item.Initialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self.eco_Content = nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    Self.eco_Content := factory.CreateContent(Self);
    Self.eco_Content.LoopbackValid;
  end;
end;

/// <summary>For Framework Internal use only</summary>
constructor c_item.Create(content: IContent);
begin
  inherited Create;
  Self.eco_Content := content;
  content.AssertLoopbackUnassigned;
end;

{$ENDREGION 'ECO generated code'}

constructor c_item.Create(serviceProvider: IEcoServiceProvider);
begin
  inherited Create;
  Self.Initialize(serviceProvider);
  try
    // User code here
  except
    on System.Exception do
    begin
      Self.Deinitialize(serviceProvider);
      raise;
    end;
  end;
end;

function c_item.get_from_invoice: c_invoice;
begin
  Result := (Package_1Unit.c_invoice(Self.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.from_invoice)));
end;

procedure c_item.set_from_invoice(Value: c_invoice);
begin
  Self.eco_Content.set_MemberByIndex(Eco_LoopbackIndices.from_invoice, (System.Object(Value)));
end;

function c_item.get_m_quantity: Integer;
begin
  Result := (Integer(Self.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.m_quantity)));
end;

procedure c_item.set_m_quantity(Value: Integer);
begin
  Self.eco_Content.set_MemberByIndex(Eco_LoopbackIndices.m_quantity, (System.Object(Value)));
end;

constructor c_item.c_itemListAdapter.Create(source: IList);
begin
  inherited Create(source);
end;

function c_item.c_itemListAdapter.get_Item(index: Integer): c_item;
begin
  Result := (c_item(inherited Adaptee[index]));
end;

procedure c_item.c_itemListAdapter.set_Item(index: Integer; Value: c_item);
begin
  inherited Adaptee[index] := value;
end;

function c_item.c_itemListAdapter.Add(value: c_item): Integer;
begin
  Result := Self.Adaptee.Add(value);
end;

function c_item.c_itemListAdapter.Contains(value: c_item): Boolean;
begin
  Result := Self.Adaptee.Contains(value);
end;

function c_item.c_itemListAdapter.IndexOf(value: c_item): Integer;
begin
  Result := Self.Adaptee.IndexOf(value);
end;

procedure c_item.c_itemListAdapter.Insert(index: Integer; value: c_item);
begin
  Self.Adaptee.Insert(index, value);
end;

procedure c_item.c_itemListAdapter.Remove(value: c_item);
begin
  Self.Adaptee.Remove(value);
end;

    function c_item.ToString: String;
      begin
        Result:= m_quantity.ToString;
      end; // ToString

{ Package_1 }


end.
